-- Sum squares of odd numbers

import Test.QuickCheck
import Criterion.Main

ho :: Int -> Int
ho n  =  (foldl (+) 0 . map (^2) . filter odd) [1..n]

comp :: Int -> Int
comp n  =  sum [ x^2 | x <- [1..n], odd x ]

rec :: Int -> Int
rec n  =  helper 0 0
  where
  helper :: Int -> Int -> Int
  helper i a | i > n      =  a
             | odd i      =  helper (i+1) (a + i^2)
             | otherwise  =  helper (i+1) a

prop_sqr :: Int -> Bool
prop_sqr n  =  a == b && b == c
  where
  a = ho n
  b = comp n
  c = rec n

main = quickCheck prop_sqr >>
       defaultMain [
         bgroup "sqr"
           [ bench "ho   1000000" (nf ho   1000000)
           , bench "comp 1000000" (nf comp 1000000)
           , bench "rec  1000000" (nf rec  1000000)
           ]
       ]